/*
Copyright (c) 2010, Cryst.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of
      conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.
    * Neither the name of the Cryst nor the names of its contributors may be used to endorse or
      promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
Copyright (c)  2010, Cryst.
All rights reserved.

  \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏𖞂ꍇ
  AĔЕzюgp܂B

      * \[XR[hĔЕzꍇAL̒쌠\A{ꗗA LƐӏ
         ܂߂邱ƁB
      * oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL̒쌠
         \A{ꗗAщLƐӏ܂߂邱ƁB
      * ʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔iɁA
         Cryst ̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB

  {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v񋟂ĂA
  َ킸AƓIȎgp\Aѓ̖ړIɑ΂KɊւÖق̕ۏ
  ܂߁A܂Ɍ肳ȂAȂۏ؂܂B쌠҂Rgr[^[
  AR̂킸AQ̌킸AӔC̍_ł邩
  iӔCł邩iߎ̑́js@sׂł邩킸Aɂ̂悤ȑQ
  \m炳ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑p
  T[rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ
  ȂjڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQɂ
  āAؐӔC𕉂Ȃ̂Ƃ܂B
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
// RpC@ gcc -O4 -Wall -m486 -o CThead2voxel CThead2voxel.c
//                         // +---------------+- - - - - - - - - - - - - - - --
//#define MAX_PATH 1024    // | wb_[  |       wb_[.vxSize -->
#define LX 256             // +---------------+                              b
#define LY 256             // |  Rg   |(Rg͖Ăǂ)    b
#define LZ 113             // +---------------+--- <- wb_[.vxOffByte b
#define LZEX (LZ*2-1)      // |  Voxel Data   | | wb_[.vxSizeImage   
                           // +---------------+- - - - - - - - - - - - - - - --
typedef struct VOXELHEADER {  // Ver 0.1 {NZ̃wb_[
  int vxType;      // int  4byte "VXL\0"  0x004C5856
  int vxSize;      // int  4byte t@CŜ̑傫[byte]
  int vxOffByte;   // int  4byte t@C̐擪Voxelf[^܂ł̃ItZbg(Byte)
  int vxLatitude;  // int  4byte Voxel̉   // ...---  cAi1wj
  int vxLongitude; // int  4byte Voxel̏c   //   :       | Ainwj
  int vxAltitude;  // int  4byte Voxel̍ // ...---
  int vxBitCount;  // int  4byte Voxel̃f[^\rbg
  int vxSizeImage; // int  4byte Voxelf[^̃oCg lx*ly*lz*sizeof(VOXEL)
} VOXELHEADER ;

typedef struct BIGENDIAN    { unsigned char B1, B0 ; }     BIGENDIAN ;
typedef struct LITTLEENDIAN { unsigned char B0, B1 ; }     LITTLEENDIAN ;
// gpł́AACg͕sv  #pragma pack(push,1) 
typedef union ENDIAN { // f[^сiGfBAj̓ւpioCgI[_[ύXj
    BIGENDIAN      BE ;
    LITTLEENDIAN   LE ;
    unsigned short US ;
} ENDIAN ;

VOXELHEADER vxhead = { 0x004C5856, sizeof(VOXELHEADER)+LX*LY*LZEX*sizeof(unsigned short),
                       sizeof(VOXELHEADER), LX, LY, LZEX, 16, LX*LY*LZEX*sizeof(unsigned short) } ;

unsigned short int voxel[LZEX][LY][LX] ; // CThead.tar.gz ̃TCY܂Ă
                   //  LZEX == (LZ*2-1)  // X:Y:Z aspectp(Z2{ɐL)

int main(int argc, char *argv[])
{
register ENDIAN endian ;
register int    i, here, x, y ;
register FILE   *fp, *fpm ;
struct stat     fileInfo ;
char            name[MAX_PATH], *fname="CThead.vxl" ;

    if( (argc != 2) && (argc != 3) ) {
        fprintf( stderr, "\nusage: %s input_raw_data_dir [output_voxel_file]\n", argv[0] ) ;
        fprintf( stderr, "\n\tThe Stanford volume data archive CTf[^_E[h܂B\n" ) ;
        fprintf( stderr, "\thttp://www-graphics.stanford.edu/data/voldata/CThead.tar.gz\n" ) ;
        fprintf( stderr, "\tA[JCo[WJi𓀁j܂B fBNg CThead 쐬܂B\n" ) ;
        fprintf( stderr, "\tʏgpł͂̃fBNgw肵܂B %s CThead\n", argv[0] ) ;
        exit(1) ;
    } else if( argc == 3 ) fname=argv[2] ;

    for( i=1; i<=LZ; i++ ) { // LZ ̃f[^fBXN烁[ɓǂݍ
        here = (i-1) * 2 ;   // ⊮pf[^wlǂݍ݈ʒǔvZ
        snprintf( name, MAX_PATH -1, "%s\\CThead.%d", argv[1], i ) ; 
        fprintf( stdout, "'%s'\r", name ) ; fflush(stdout) ;//CT摜̃t@C
        if ( (fp=fopen(name,"rb")) == NULL ) { // wfBNg̓ǂݍ
            fprintf( stderr, "'%s' open error.\n", name ) ;
            exit(1) ;
        } else if( fread(&voxel[here][0][0], LX*LY*sizeof(unsigned short), 1, fp) != 1 ) {
            fprintf( stderr, "'%s' read error.\n", name ) ;
            fclose(fp) ;  exit(1) ;
        } else fclose(fp) ;
#define ENDIANISINTEL
#ifdef ENDIANISINTEL                // ENDIANISINTEL 錾ĂꍇɗL
        for( y=0; y<LY; y++ ) {     // f[^сiGfBAj̓ւ
            for( x=0; x<LX; x++ ) { // short(QoCg) ̏㉺oCg̓ւ
                endian.LE.B0 = ((union ENDIAN)(voxel[here][y][x])).BE.B0 ;
                endian.LE.B1 = ((union ENDIAN)(voxel[here][y][x])).BE.B1 ;
                voxel[here][y][x] = endian.US ;
            }
        } // fprintf( stdout, "f[^INTELigGfBAjɕϊ܂\n" ) ;
#endif
    }
    fprintf( stdout, "\n\nCT f[^̓ǂݍ݂܂\n" ) ;

    for( i=0; i<LZ-1; i++ ) { // X:Y:Z aspect: Z2{ɐL
        for( y=0; y<LY; y++ ) {
            for( x=0; x<LX; x++ ) {  // ⊮̐x͖APȕ⊮
                voxel[i*2+1][y][x] = ( voxel[i*2][y][x] + voxel[(i+1)*2][y][x] ) / 2 ;
            }
        }
    }
    fprintf( stdout, "CT f[^̕⊮Ƃ܂\n" ) ;

    for( i=0; i<LZEX; i++ ) { // IWi̕Ȃ16rbgf[^pɉH
        for( y=0; y<LY; y++ ) {     // ʂ4rbĝ݂gp
            for( x=0; x<LX; x++ ) { // 1f[^8rbgɕϊAʂ8rbg͎gpȂ
                voxel[i][y][x] = (0xF80 & voxel[i][y][x]) >> 4 ;
            }
        }
    }
    fprintf( stdout, "CT f[^̕ϊƂ܂\n" ) ;

    // Voxel f[^̏o
    fileInfo.st_size = 0 ; // bZ[Wt@ĆiO͌Œ"massage.html"j̏
    if ( (fpm=fopen("massage.html","rb")) != NULL ) { // Rgt@Cꍇ
        if ( fstat(fileno(fpm), &fileInfo) != 0 ) {
            fprintf( stderr, "'%s' stat error.\n", "massage.html" );
            fclose(fpm) ;
        } else if( fileInfo.st_size == 0 ) fclose(fpm) ;
        fprintf( stdout, "Rgt@C '%s:%d Byte' ܂B\n", "massage.html", (int)fileInfo.st_size );
        vxhead.vxSize    += fileInfo.st_size ;
        vxhead.vxOffByte += fileInfo.st_size ;
    } else fprintf( stdout, "Voxel f[^ɖߍރRgt@C'%s'́A܂łB\n", "massage.html" );

    // Voxelf[^̏ot@ĆAfname Ŏw肳
    if ( (fp=fopen(fname,"wb")) == NULL ) {    // Voxel f[^̏opt@C쐬
        fprintf( stderr, "'%s' open error.\n", fname ) ;
        exit(1) ;
    } else if( fwrite(&vxhead, sizeof(VOXELHEADER), 1, fp) != 1 ) {//wb_[̏o
        fprintf( stderr, "'%s' write error.\n", fname ) ;
        fclose(fp) ;  exit(1) ;
    }
    if( fileInfo.st_size != 0 ) { // Rgt@Cꍇ̏iRg̏oj
        register int i=0 ;
        while( i++<fileInfo.st_size ) fputc( fgetc(fpm), fp ) ;
        fclose(fpm) ;
    } // Rg̃CvgI
    if( fwrite(voxel, vxhead.vxSizeImage, 1, fp) != 1 ) {// Voxel f[^{̂̏o
        fprintf( stderr, "'%s' write error.\n", fname ) ;
        fclose(fp) ;  exit(1) ;
    }
    fclose(fp) ;
    
    return 0 ;
}
