/*
Copyright (c) 2010, Cryst.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of
      conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.
    * Neither the name of the Cryst nor the names of its contributors may be used to endorse or
      promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
Copyright (c)  2010, Cryst.
All rights reserved.

  \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏𖞂ꍇ
  AĔЕzюgp܂B

      * \[XR[hĔЕzꍇAL̒쌠\A{ꗗA LƐӏ
         ܂߂邱ƁB
      * oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL̒쌠
         \A{ꗗAщLƐӏ܂߂邱ƁB
      * ʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔iɁA
         Cryst ̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB

  {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v񋟂ĂA
  َ킸AƓIȎgp\Aѓ̖ړIɑ΂KɊւÖق̕ۏ
  ܂߁A܂Ɍ肳ȂAȂۏ؂܂B쌠҂Rgr[^[
  AR̂킸AQ̌킸AӔC̍_ł邩
  iӔCł邩iߎ̑́js@sׂł邩킸Aɂ̂悤ȑQ
  \m炳ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑p
  T[rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ
  ȂjڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQɂ
  āAؐӔC𕉂Ȃ̂Ƃ܂B
*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
/* RpC@
gcc -O4 -Wall -m486 -o showVoxelHeader showVoxelHeader.c
*/
typedef struct VOXELHEADER {  // Ver 0.1
  int vxType;      // int  4byte "VXL\0"  0x004C5856
  int vxSize;      // int  4byte t@CŜ̑傫[byte]
  int vxOffByte;   // int  4byte t@C̐擪Voxelf[^܂ł̃ItZbg(Byte)
  int vxLatitude;  // int  4byte Voxel̉ (lx)
  int vxLongitude; // int  4byte Voxel̏c (ly)
  int vxAltitude;  // int  4byte Voxel̍ (lz)
  int vxBitCount;  // int  4byte Voxel̃f[^\rbg@sizeof(VOXEL)*8 ȉ
                   //            VOXEL Big endian ̏ꍇ͕lŕ\L
  int vxSizeImage; // int  4byte Voxelf[^̃oCg lx*ly*lz*sizeof(VOXEL)
} VOXELHEADER ;

void dumpVoxelHeader(void *raw, int fs)
{
register int  i, l ;
register char *msg=(char *)raw ;
register VOXELHEADER *VH=(VOXELHEADER *)raw ;

    fprintf( stderr, "\nfile size = %d\n\n", fs ) ;
    fprintf( stderr, "typedef struct VOXELHEADER {\n" ) ;
    fprintf( stderr, "  int vxType;      // int  4byte  %4.4X\n", VH->vxType) ;
    fprintf( stderr, "  int vxSize;      // int  4byte  %d\n", VH->vxSize ) ;
    fprintf( stderr, "  int vxOffByte;   // int  4byte  %d\n", VH->vxOffByte ) ;
    fprintf( stderr, "  int vxLatitude;  // int  4byte  %d\n", VH->vxLatitude ) ;
    fprintf( stderr, "  int vxLongitude; // int  4byte  %d\n", VH->vxLongitude ) ;
    fprintf( stderr, "  int vxAltitude;  // int  4byte  %d\n", VH->vxAltitude ) ;
    fprintf( stderr, "  int vxBitCount;  // int  4byte  %d\n", VH->vxBitCount ) ;
    fprintf( stderr, "  int vxSizeImage; // int  4byte  %d\n", VH->vxSizeImage) ;
    fprintf( stderr, "} VOXELHEADER ;\n" ) ;
    fprintf( stderr, "\n" ) ;
    fprintf( stderr, "----------------------------------------\n" ) ;
    i = sizeof(VOXELHEADER) ;
    for( l=VH->vxOffByte; i<l; putc(msg[i++], stdout) ) ;
    fprintf( stderr, "----------------------------------------\n\n" ) ;
}

int main(int argc, char *argv[])
{
struct stat fileInfo ;
void        *raw=NULL ;
FILE        *fp ;

    if( argc != 2 ) {
        fprintf( stderr, "usage: %s input_voxel_file\n", argv[0] ) ;
        exit(1) ;
    }
    if ( (fp=fopen(argv[1],"rb")) == NULL ) {
        fprintf( stderr, "'%s' open error.\n", argv[1] ) ;
        exit(1) ;
    } else if ( fstat(fileno(fp), &fileInfo) != 0 ) {
        fprintf( stderr, "'%s' stat error.\n", argv[1] ) ;
        fclose(fp) ;
        exit(1) ;
    } else if ( (raw=malloc(fileInfo.st_size)) == NULL ) {
        fprintf( stderr, "malloc error.\n" ) ;
        exit(1) ;
    } else if( fread(raw, fileInfo.st_size, 1, fp) != 1 ) {
        fprintf( stderr, "'%s' read error.\n", argv[1] ) ;
        fclose(fp) ;
        free(raw) ;
        exit(1) ;
    } else fclose(fp) ;
    dumpVoxelHeader( raw, fileInfo.st_size ) ;
//  f[^ۑ saveRawData(t@CAVoxelf[^̊JnꏊAVoxelf[^̑傫(Byte))
//  saveRawData("voxel.raw",(char*)raw+(*(VOXELHEADER*)raw).vxOffByte,(*(VOXELHEADER*)raw).vxSizeImage) ;
    free(raw) ;
    return 0 ;
}
